# --------------------------------------------------------------------
# --   *****************************
# --   *   Trenz Electronic GmbH   *
# --   *   Holzweg 19A             *
# --   *   32257 Bünde             *
# --   *   Germany                 *
# --   *****************************
# --------------------------------------------------------------------
# --$Autor: Hartfiel, John $
# --$Email: j.hartfiel@trenz-electronic.de $
# --$Create Date:2017/09/04 $
# --$Modify Autor: Hartfiel, John $
# --$Modify Date: 2017/09/04 $
# --$Modify Autor: Pohl, Zdenek $
# --$Modify Date: 2018/02/01 $
# --------------------------------------------------------------------
# --------------------------------------------------------------------
TE::UTILS::te_msg TE_PS-0 INFO "SDSoC PS Modification: Add all PS-PL CLKs and IRQ"
set_property -dict [ list \
  CONFIG.PSU__FPGA_PL0_ENABLE {1} \
  CONFIG.PSU__FPGA_PL1_ENABLE {1} \
  CONFIG.PSU__FPGA_PL2_ENABLE {1} \
  CONFIG.PSU__FPGA_PL3_ENABLE {1} \
  CONFIG.PSU__CRL_APB__PL0_REF_CTRL__FREQMHZ {100} \
  CONFIG.PSU__CRL_APB__PL1_REF_CTRL__FREQMHZ {25} \
  CONFIG.PSU__CRL_APB__PL2_REF_CTRL__FREQMHZ {150} \
  CONFIG.PSU__CRL_APB__PL3_REF_CTRL__FREQMHZ {200} \
  CONFIG.PSU__USE__IRQ0 {1} \
  CONFIG.PSU__USE__IRQ1 {1} \
  CONFIG.PSU__USE__S_AXI_GP2 {1} \
  CONFIG.PSU__USE__AUDIO {0} \
 ] [get_bd_cells -hierarchical -filter {VLNV=~"*zynq_ultra_ps_e*"}]


# SDSoC properties for export of hw platform

# set sdsoc platform name
set bd_file [glob -join -dir ${TE::VPROJ_PATH}/${TE::VPROJ_NAME}.srcs/${TE::SOURCE_NAME}/bd/ * *.bd]
set_property PFM_NAME "trenz.biz:${design_name}:${design_name}:1.0" [get_files $bd_file]

# define clock ports
set_property PFM.CLOCK {\
pl_clk1 { id "0" is_default "false" proc_sys_reset "proc_sys_reset_0"}\
pl_clk0 { id "1" is_default "true"  proc_sys_reset "proc_sys_reset_1"}\
pl_clk2 { id "2" is_default "false" proc_sys_reset "proc_sys_reset_2"}\
pl_clk3 { id "3" is_default "false" proc_sys_reset "proc_sys_reset_3"}\
} [get_bd_cells /zynq_ultra_ps_e_0]

# define AXI ports
# S_AXI_HP0_FPD {memport "S_AXI_HP" sptag "HP0"} \ # reserved for VDMA
set_property PFM.AXI_PORT { \
 M_AXI_HPM0_FPD {memport "M_AXI_GP"} \
 M_AXI_HPM1_FPD {memport "M_AXI_GP"} \
 M_AXI_HPM0_LPD {memport "M_AXI_GP"} \
 S_AXI_HPC0_FPD {memport "S_AXI_HPC" sptag "HPC0"} \
 S_AXI_HPC1_FPD {memport "S_AXI_HPC" sptag "HPC1"} \
 S_AXI_HP1_FPD {memport "S_AXI_HP" sptag "HP1"} \
 S_AXI_HP2_FPD {memport "S_AXI_HP" sptag "HP2"} \
 S_AXI_HP3_FPD {memport "S_AXI_HP" sptag "HP3"} \
 } [get_bd_cells /zynq_ultra_ps_e_0]

# define interrupt ports, number of possible interrupts limited to 16
# for ZUS+ in two separate 8bit ps ports
set intVar0 []
for {set i 2} {$i < 8} {incr i} {
    lappend intVar0 In$i {}
}

set intVar1 []
for {set i 0} {$i < 8} {incr i} {
    lappend intVar1 In$i {}
}
puts $intVar0
puts $intVar1

set_property PFM.IRQ $intVar0 [get_bd_cells /xlconcat_0]
set_property PFM.IRQ $intVar1 [get_bd_cells /xlconcat_1]
