
#ifndef OPTFLOW_H
#define OPTFLOW_H

#include "frame_size.h"
//#define FUNC_DBG

typedef unsigned char pix_t;
typedef unsigned short yuv_t;

#define LB_WIDTH 1920

#define KMED 53//53
#define KMEDP1 (KMED+1)

#ifdef __cplusplus
extern "C" {
#endif

int fpga_optflow (yuv_t *frame0, yuv_t *frame1, yuv_t *framef,
		int height, int width, int stride, float clip_flowmag);



#pragma SDS data access_pattern(matB:SEQUENTIAL, pixStream:SEQUENTIAL)
#pragma SDS data mem_attribute(matB:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
void readMatRows (yuv_t matB[NUMROWS*NUMPADCOLS], pix_t pixStream[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(pixStream:SEQUENTIAL, dst:SEQUENTIAL)
#pragma SDS data mem_attribute(dst:PHYSICAL_CONTIGUOUS|NON_CACHEABLE)
void writeMatRows (yuv_t pixStream[NUMROWS*NUMCOLS], yuv_t dst[NUMROWS*NUMPADCOLS]);

#pragma SDS data access_pattern(f0Stream:SEQUENTIAL, f1Stream:SEQUENTIAL)
#pragma SDS data access_pattern(ixix_out:SEQUENTIAL, ixiy_out:SEQUENTIAL, iyiy_out:SEQUENTIAL)
#pragma SDS data access_pattern(dix_out:SEQUENTIAL, diy_out:SEQUENTIAL)
void computeSum(pix_t f0Stream[NUMROWS*NUMCOLS], pix_t f1Stream[NUMROWS*NUMCOLS],
		int ixix_out[NUMROWS*NUMCOLS], int ixiy_out[NUMROWS*NUMCOLS], int iyiy_out[NUMROWS*NUMCOLS],
		int  dix_out[NUMROWS*NUMCOLS], int diy_out[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(ixix:SEQUENTIAL, ixiy:SEQUENTIAL, iyiy:SEQUENTIAL)
#pragma SDS data access_pattern(dix:SEQUENTIAL, diy:SEQUENTIAL)
#pragma SDS data access_pattern(fx_out:SEQUENTIAL, fy_out:SEQUENTIAL)
void computeFlow(int ixix[NUMROWS*NUMCOLS], int ixiy[NUMROWS*NUMCOLS], int iyiy[NUMROWS*NUMCOLS],
		int dix[NUMROWS*NUMCOLS], int diy[NUMROWS*NUMCOLS],
		float fx_out[NUMROWS*NUMCOLS], float fy_out[NUMROWS*NUMCOLS]);

#pragma SDS data access_pattern(fx:SEQUENTIAL, fy:SEQUENTIAL, out_pix:SEQUENTIAL)
void getOutPix (float fx[NUMROWS*NUMCOLS], float fy[NUMROWS*NUMCOLS], yuv_t out_pix[NUMROWS*NUMCOLS],
		float clip_flowmag);

#ifdef __cplusplus
}
#endif

#endif

